Index: palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3297)
+++ palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3298)
@@ -4652,27 +5144,115 @@
 !
 !--    Get variable
-       nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
+          nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
                                start = (/ is+1,    js+1,   k1s+1, k2s+1 /),    &
                                count = (/ ie-is+1, je-js+1,                    &
                                           k1e-k1s+1, k2e-k2s+1 /) )
 
-       CALL handle_error( 'get_variable_4d_real', 535, variable_name )
+          CALL handle_error( 'get_variable_4d_real', 535, variable_name )
 !
 !--    Resort data. Please note, dimension subscripts of var all start at 1. 
-       DO  i = is, ie 
-          DO  j = js, je
-             DO  k1 = k1s, k1e
-                DO  k2 = k2s, k2e
-                   var(k2-k2s+1,k1-k1s+1,j-js+1,i-is+1) = tmp(i,j,k1,k2)
+          DO  i = is, ie 
+             DO  j = js, je
+                DO  k1 = k1s, k1e
+                   DO  k2 = k2s, k2e
+                      var(k2-k2s+1,k1-k1s+1,j-js+1,i-is+1) = tmp(i,j,k1,k2)
+                   ENDDO
                 ENDDO
              ENDDO
           ENDDO
-       ENDDO
        
-       DEALLOCATE( tmp )
+          DEALLOCATE( tmp )
+       ENDIF
 #endif
     END SUBROUTINE get_variable_4d_real
 
-
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Reads a 4D float variable from file and store it to a 3-d variable.
+!------------------------------------------------------------------------------!
+    SUBROUTINE get_variable_4d_to_3d_real( id, variable_name, var, ns, is, ie, js, je,   &
+                                           ks, ke )
+
+       USE indices
+       USE pegrid
+
+       IMPLICIT NONE
+
+       CHARACTER(LEN=*)              ::  variable_name   !< variable name
+
+       INTEGER(iwp)                  ::  ns              !< start index for subdomain input along n dimension: ns coincides here with ne, since, we select only one value along the 1st dimension n
+
+       INTEGER(iwp)                  ::  i               !< index along x direction
+       INTEGER(iwp)                  ::  ie              !< end index for subdomain input along x direction
+       INTEGER(iwp)                  ::  is              !< start index for subdomain input along x direction
+       INTEGER(iwp), INTENT(IN)      ::  id              !< file id
+       INTEGER(iwp)                  ::  id_var          !< variable id
+       INTEGER(iwp)                  ::  j               !< index along y direction
+       INTEGER(iwp)                  ::  je              !< end index for subdomain input along y direction
+       INTEGER(iwp)                  ::  js              !< start index for subdomain input along y direction
+       INTEGER(iwp)                  ::  k               !< index along any 4th dimension
+       INTEGER(iwp)                  ::  ke              !< end index of 4th dimension
+       INTEGER(iwp)                  ::  ks              !< start index of 4th dimension
+       
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp !< temporary variable to read data from file according 
+                                                         !< to its reverse memory access
+
+       REAL(wp), DIMENSION(:,:,:), INTENT(INOUT) ::  var  !< variable where the read data have to be stored: one dimension is reduced in the process
+#if defined( __netcdf )
+
+!
+!--    Inquire variable id
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )  
+!
+!--    Check for collective read-operation and set respective NetCDF flags if
+!--    required. 
+       IF ( collective_read )  THEN
+          nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
+       ENDIF
+
+      !Temporary solution for reading emission chemistry files: 
+       IF ( id==id_emis ) THEN
+
+          !--    Allocate temporary variable according to memory access on file. 
+          ALLOCATE( tmp(is:ie,js:je,ks:ke) )
+
+          !--    Get variable
+          nc_stat = NF90_GET_VAR( id, id_var, tmp(is:ie,js:je,ks:ke),                                &
+                                  start = (/ ns, is,   js+1,   ks+1 /),                  &
+                                  count = (/ 1, ie-is+1 , je-js+1, ke-ks+1 /) ) 
+
+          var=tmp(:,:,:)
+
+          CALL handle_error( 'get_variable_4d_to_3d_real', 536, variable_name )
+ 
+          DEALLOCATE( tmp )
+
+       ELSE
+!
+!--    Allocate temporary variable according to memory access on file. 
+          ALLOCATE( tmp(is:ie,js:je,ks:ke) )
+!
+!--    Get variable
+          nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
+                                  start = (/ ns+1, is+1,    js+1,    ks+1 /),           &
+                                  count = (/ 1, ie-is+1, je-js+1, ke-ks+1 /) )   
+                               
+          CALL handle_error( 'get_variable_4d_to_3d_real', 536, variable_name )
+!
+!--    Resort data. Please note, dimension subscripts of var all start at 1. 
+          DO  i = is, ie 
+             DO  j = js, je
+                DO  k = ks, ke
+                   var(k-ks+1,j-js+1,i-is+1) = tmp(i,j,k)
+                ENDDO
+             ENDDO
+          ENDDO
+       
+         DEALLOCATE( tmp )
+
+       ENDIF
+#endif
+    END SUBROUTINE get_variable_4d_to_3d_real
 
 !------------------------------------------------------------------------------!
@@ -4755,5 +5335,5 @@
                                count = (/ count_1, count_2, count_3 /) )
 
-       CALL handle_error( 'get_variable_3d_real_dynamic', 536, variable_name )
+       CALL handle_error( 'get_variable_3d_real_dynamic', 537, variable_name )
 !
 !--    Resort data. Please note, dimension subscripts of var all start at 1. 
@@ -4770,4 +5350,98 @@
     END SUBROUTINE get_variable_3d_real_dynamic
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Reads a 5D float variable from file and store it to a 4-d variable.
+!------------------------------------------------------------------------------!
+    SUBROUTINE get_variable_5d_to_4d_real( id, variable_name, var,              &
+                                           ns, ts, te, is, ie, js, je, ks, ke )
+
+       USE indices
+       USE pegrid
+
+       IMPLICIT NONE
+
+       CHARACTER(LEN=*)              ::  variable_name   !< variable name
+
+       INTEGER(iwp)                  ::  ns              !< start index for subdomain input along n dimension: ns coincides here with ne, since, we select only one value along the 1st dimension n
+
+       INTEGER(iwp)                  ::  t               !< index along t direction
+       INTEGER(iwp)                  ::  te              !< end index for subdomain input along t direction
+       INTEGER(iwp)                  ::  ts              !< start index for subdomain input along t direction
+
+       INTEGER(iwp)                  ::  i               !< index along x direction
+       INTEGER(iwp)                  ::  ie              !< end index for subdomain input along x direction
+       INTEGER(iwp)                  ::  is              !< start index for subdomain input along x direction
+       INTEGER(iwp), INTENT(IN)      ::  id              !< file id
+       INTEGER(iwp)                  ::  id_var          !< variable id
+       INTEGER(iwp)                  ::  j               !< index along y direction
+       INTEGER(iwp)                  ::  je              !< end index for subdomain input along y direction
+       INTEGER(iwp)                  ::  js              !< start index for subdomain input along y direction
+       INTEGER(iwp)                  ::  k               !< index along any 5th dimension
+       INTEGER(iwp)                  ::  ke              !< end index of 5th dimension
+       INTEGER(iwp)                  ::  ks              !< start index of 5th dimension
+       
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE   ::  tmp !< temporary variable to read data from file according 
+                                                           ! to its reverse memory access
+       REAL(wp), DIMENSION(:,:,:,:), INTENT(INOUT) ::  var !< variable to be read
+#if defined( __netcdf )
+!
+!--    Inquire variable id
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )  
+!
+!--    Check for collective read-operation and set respective NetCDF flags if
+!--    required. 
+       IF ( collective_read )  THEN
+          nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
+       ENDIF
+
+      !Temporary solution for reading emission chemistry files: 
+       IF ( id==id_emis ) THEN
+
+          !--    Allocate temporary variable according to memory access on file. 
+          ALLOCATE( tmp(ts:te,1,js+1:je+1,ks+1:ke+1) )
+
+          !--    Get variable
+          nc_stat = NF90_GET_VAR( id, id_var, tmp(ts:te,1,js+1:je+1,ks+1:ke+1),               &
+                                  start = (/ ns, ts,  1,   js+1,   ks+1 /),                  &
+                                  count = (/ 1, te-ts+1, 1, je-js+1, ke-ks+1 /) ) 
+
+          var=tmp
+
+          CALL handle_error( 'get_variable_5d_to_4d_real', 538, variable_name )
+ 
+          DEALLOCATE( tmp )
+
+       !>  Original Subroutine part
+       ELSE
+!
+!--    Allocate temporary variable according to memory access on file. 
+          ALLOCATE( tmp(ks:ke,js:je,is:is,ts:te) )
+!
+!--    Get variable
+          nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
+                                  start = (/ ks+1, js+1, is+1, ts+1, ns /),           &
+                                  count = (/ ke-ks+1, je-js+1, ie-is+1, te-ts+1, 1 /) )   
+                               
+          CALL handle_error( 'get_variable_5d_to_4d_real', 538, variable_name )
+!
+!--    Resort data. Please note, dimension subscripts of var all start at 1. 
+
+          DO  t = ts, te 
+             DO  i = is, ie 
+                DO  j = js, je
+                   DO  k = ks, ke
+                      var(t-ts+1,i-is+1,j-js+1,k-ks+1) = tmp(k,j,i,t)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDDO 
+
+         DEALLOCATE( tmp )
+
+       ENDIF
+#endif
+    END SUBROUTINE get_variable_5d_to_4d_real
 
 
@@ -4789,5 +5463,5 @@
 
        nc_stat = NF90_INQUIRE( id, NVARIABLES = num_vars )
-       CALL handle_error( 'inquire_num_variables', 537 )
+       CALL handle_error( 'inquire_num_variables', 539 )
 
 #endif
@@ -4816,9 +5490,9 @@
        ALLOCATE( varids(1:SIZE(var_names)) )
        nc_stat = NF90_INQ_VARIDS( id, NVARS = num_vars, VARIDS = varids )
-       CALL handle_error( 'inquire_variable_names', 538 )
+       CALL handle_error( 'inquire_variable_names', 540 )
 
        DO  i = 1, SIZE(var_names)
           nc_stat = NF90_INQUIRE_VARIABLE( id, varids(i), NAME = var_names(i) )
-          CALL handle_error( 'inquire_variable_names', 538 )
+          CALL handle_error( 'inquire_variable_names', 540 )
        ENDDO
 
Index: palm/trunk/SOURCE/outflow_turbulence.f90
===================================================================
--- palm/trunk/SOURCE/outflow_turbulence.f90	(revision 3297)
+++ palm/trunk/SOURCE/outflow_turbulence.f90	(revision 3298)
@@ -24,5 +24,5 @@
 ! Former revisions:
 ! -----------------
-! $Id$
+! $Id: outflow_turbulence.f90 3241 2018-09-12 15:02:00Z raasch $
 ! unused variables removed
 ! 
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 3297)
+++ palm/trunk/SOURCE/palm.f90	(revision 3298)
@@ -25,4 +25,12 @@
 ! -----------------
 ! $Id$
+! - Minor formatting (kanani)
+! - Added Call of date_and_time_init (Russo)
+! - Added Call of calc_date_and_time before call of init_3d where emissions 
+!   are initialized:
+!   we have to know the time indices to initialize emission values (Russo)
+! - Added Call of netcdf_data_input_chemistry_data (Russo)
+!
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -241,9 +249,15 @@
     USE arrays_3d
 
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
+
+    USE chem_modules,                                                          &
+        ONLY:  do_emis
+
     USE chemistry_model_mod,                                                   &
-        ONLY:  chem_init
-
-    USE chem_photolysis_mod,                                                   &
-        ONLY:  photolysis_init
+        ONLY:  chem_check_data_output_pr, chem_init
+
+!    USE chem_photolysis_mod,                                                   &
+!        ONLY:  photolysis_init
 
     USE control_parameters,                                                    &
@@ -259,4 +273,7 @@
         ONLY:  cpu_log, log_point, log_point_s, cpu_statistics
 
+    USE date_and_time_mod,                                                     &
+        ONLY:  calc_date_and_time, init_date_and_time
+
     USE indices,                                                               &
         ONLY:  nbgp
@@ -264,12 +281,10 @@
     USE kinds
 
-    USE bulk_cloud_model_mod,                                                  &
-        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
-
     USE multi_agent_system_mod,                                                &
         ONLY:  agents_active, mas_last_actions
 
     USE netcdf_data_input_mod,                                                 &
-        ONLY:  netcdf_data_input_inquire_file, netcdf_data_input_init,         &
+        ONLY:  chem_emis, chem_emis_att, netcdf_data_input_chemistry_data,     &
+               netcdf_data_input_inquire_file, netcdf_data_input_init,         &
                netcdf_data_input_surface_data, netcdf_data_input_topo
 
@@ -410,7 +425,15 @@
 !-- --> Needs to be moved!! What is the dependency about?
 ! IF (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
-    IF ( air_chemistry )  THEN
+    IF ( air_chemistry  .AND.  do_emis )  THEN
+
+       IF ( do_emis ) THEN
+          CALL netcdf_data_input_chemistry_data(chem_emis_att,chem_emis)
+       ENDIF
+
        CALL chem_init
-       CALL photolysis_init   ! probably also required for restart
+!       CALL photolysis_init   ! probably also required for restart
+
+       CALL init_date_and_time     !initialize the time of chemistry emissions
+
     ENDIF
 ! END IF
@@ -421,4 +444,6 @@
 !
 !-- Initialize all necessary variables
+    CALL calc_date_and_time !this is required for chemistry emissions
+
     CALL init_3d_model
 
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 3297)
+++ palm/trunk/SOURCE/parin.f90	(revision 3298)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Introduced reading of date_init to inipar.(Russo)
+! Add extra profiles for chemistry (basit)
+!
+! 3294 2018-10-01 02:37:10Z raasch
 ! changes concerning modularization of ocean option
 ! 
@@ -421,4 +425,6 @@
 ! ------------
 !> This subroutine reads variables controling the run from the NAMELIST files
+!>
+!> @todo: Revise max_pr_cs (profiles for chemistry)
 !------------------------------------------------------------------------------!
  SUBROUTINE parin
@@ -443,5 +449,5 @@
 
     USE date_and_time_mod,                                                     &
-        ONLY:  day_of_year_init, time_utc_init
+        ONLY:  date_init, day_of_year_init, time_utc_init
 
     USE dvrp_variables,                                                        &
@@ -548,4 +554,5 @@
              cycle_mg, damp_level_1d,                                          &
              data_output_during_spinup,                                        &
+             date_init,                                                        &
              day_of_year_init,                                                 &
              dissipation_1d,                                                   &
@@ -620,4 +627,5 @@
              cycle_mg, damp_level_1d,                                          &
              data_output_during_spinup,                                        &
+             date_init,                                                        &
              day_of_year_init,                                                 &
              dissipation_1d,                                                   &
@@ -1066,6 +1074,6 @@
                        ref_state(0:nz+1), sa_init(0:nz+1), ug(0:nz+1),         &
                        u_init(0:nz+1), v_init(0:nz+1), vg(0:nz+1),             &
-                       hom(0:nz+1,2,pr_palm+max_pr_user,0:statistic_regions),  &
-                       hom_sum(0:nz+1,pr_palm+max_pr_user,0:statistic_regions) )
+                       hom(0:nz+1,2,pr_palm+max_pr_user+max_pr_cs,0:statistic_regions),  &
+                       hom_sum(0:nz+1,pr_palm+max_pr_user+max_pr_cs,0:statistic_regions) )
 
              hom = 0.0_wp
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 3297)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 3298)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Code added for decycling chemistry (basit)
+!
+! 3294 2018-10-01 02:37:10Z raasch
 ! changes concerning modularization of ocean option
 ! 
@@ -335,6 +338,6 @@
 
     USE chemistry_model_mod,                                                   &
-        ONLY:  chem_integrate, chem_prognostic_equations,                      &
-               chem_species, nspec, nvar, spc_names
+        ONLY:  chem_integrate, chem_species,  chem_prognostic_equations,       &
+               nspec, nvar, spc_names, chem_boundary_conds
            
     USE chem_modules,                                                          &
@@ -343,4 +346,7 @@
     USE chem_photolysis_mod,                                                   &
         ONLY:  photolysis_control
+
+    USE chem_modules,                                                          &
+        ONLY:  call_chem_at_all_substeps, chem_gasphase_on, cs_name
 
     USE control_parameters,                                                    &
@@ -456,5 +462,7 @@
 
     LOGICAL      ::  loop_start          !<
-    INTEGER      ::  n, lsp              !< lsp running index for chem spcs
+    INTEGER(iwp) ::  n
+    INTEGER(iwp) :: lsp
+    INTEGER(iwp) :: lsp_usr              !< lsp running index for chem spcs
 
 
@@ -468,4 +476,5 @@
 !-- concentrations of chemical species                                    
     IF ( air_chemistry )  THEN
+       lsp_usr = 1
 !
 !--    If required, calculate photolysis frequencies - 
@@ -492,6 +501,17 @@
 !--    Loop over chemical species       
        CALL cpu_log( log_point_s(84), 'chemistry exch-horiz ', 'start' )
-       DO  n = 1, nspec
-          CALL exchange_horiz( chem_species(n)%conc, nbgp )     
+       DO  lsp = 1, nspec
+          CALL exchange_horiz( chem_species(lsp)%conc, nbgp )    
+          lsp_usr = 1  
+          DO WHILE ( TRIM( cs_name( lsp_usr ) ) /= 'novalue' )
+             IF ( TRIM(chem_species(lsp)%name) == TRIM(cs_name(lsp_usr)) )  THEN
+
+                CALL chem_boundary_conds( chem_species(lsp)%conc_p,                                 &
+                                          chem_species(lsp)%conc_pr_init ) 
+             
+             ENDIF
+             lsp_usr = lsp_usr +1
+          ENDDO
+         
        ENDDO
        CALL cpu_log( log_point_s(84), 'chemistry exch-horiz ', 'stop' )
Index: palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 3297)
+++ palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 3298)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Added chemistry profiles for restart run (basit)
+! 
+! 3294 2018-10-01 02:37:10Z raasch
 ! changes concerning modularization of ocean option
 ! 
@@ -75,4 +78,6 @@
 ! ------------
 !> Reads restart data from restart-file(s) (binary format).
+!>
+!> @todo: Revise max_pr_cs (profiles for chemistry)
 !------------------------------------------------------------------------------!
  MODULE read_restart_data_mod
@@ -80,4 +85,8 @@
 
     USE control_parameters
+
+    USE chem_modules,                                                                              &
+       ONLY: max_pr_cs
+
 
     IMPLICIT NONE
@@ -266,6 +275,6 @@
                     v_init(0:nz+1), pt_init(0:nz+1), q_init(0:nz+1),           &
                     ref_state(0:nz+1), s_init(0:nz+1), sa_init(0:nz+1),        &
-                    hom(0:nz+1,2,pr_palm+max_pr_user,0:statistic_regions),     &
-                    hom_sum(0:nz+1,pr_palm+max_pr_user,0:statistic_regions) )
+                    hom(0:nz+1,2,pr_palm+max_pr_user+max_pr_cs,0:statistic_regions),     &
+                    hom_sum(0:nz+1,pr_palm+max_pr_user+max_pr_cs,0:statistic_regions) )
        ENDIF
 
Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 3297)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 3298)
@@ -26,4 +26,16 @@
 ! -----------------
 ! $Id$
+! - Minor formatting/clean-up (kanani)
+! - Removed initialization of cssws with surface_csflux values. Only the value 0 
+!   is now passed to all the chemical species of the selected mechanism. 
+!   The real inizialization is conducted in init_3d_model_mod.f90 (Russo)
+! - Added calls and variables for inizialization of chemistry emission 
+!   fluxes (Russo)
+! - Setting of cssws to zero moved (forkel)
+! - Set cssws to zero before setting values (forkel)
+! - Distinguish flux conversion factors for gases and PM (forkel)
+! - Some questions/todo's on conversion factors (forkel)
+!
+! 3294 2018-10-01 02:37:10Z raasch
 ! changes concerning modularization of ocean option
 ! 
@@ -2071,4 +2083,5 @@
 
              TYPE( surf_type ) :: surf          !< respective surface type
+
 !
 !--          Store indices of respective surface element
@@ -2173,5 +2186,9 @@
 
              DO  lsp = 1, nvar
-                IF ( air_chemistry )  surf%css(lsp,num_h) = 0.0_wp
+                IF ( air_chemistry )  surf%css(lsp,num_h)   = 0.0_wp
+!
+!--             Ensure that fluxes of compounds which are not specified in 
+!--             namelist are all zero --> kanani: revise
+                IF ( air_chemistry )  surf%cssws(lsp,num_h) = 0.0_wp
              ENDDO
 !
@@ -2220,5 +2237,5 @@
                    ELSE
                       surf%qsws(num_h) = wall_humidityflux(5) *                &
-                                             heatflux_input_conversion(k)
+                                                waterflux_input_conversion(k)
                    ENDIF
                 ENDIF
@@ -2227,5 +2244,5 @@
                    IF ( upward_facing )  THEN
                       IF ( constant_scalarflux )  THEN
-                         surf%ssws(num_h) = surface_scalarflux * rho_air_zw(k-1)
+                         surf%ssws(num_h) = surface_scalarflux  * rho_air_zw(k-1)
 
                          IF ( k-1 /= 0 )                                       &
@@ -3386,4 +3403,5 @@
                                   nxr_on_file, nynf, nync, nyn_on_file, nysf,  &
                                   nysc, nys_on_file, found )
+
 
        IMPLICIT NONE
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 3297)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 3298)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! - Formatting, clean-up, comments (kanani)
+! - Added CALL to chem_emissions_setup (Russo)
+! - Code added for decycling chemistry (basit)
+! 
+! 3294 2018-10-01 02:37:10Z raasch
 ! changes concerning modularization of ocean option
 ! 
@@ -380,9 +385,13 @@
         ONLY:  calc_mean_profile
 
+    USE chem_emissions_mod,                                                    &
+        ONLY:  chem_emissions_setup
+
+    USE chem_modules,                                                          &
+        ONLY:  bc_cs_t_val, call_chem_at_all_substeps, cs_name,                &
+               constant_csflux, do_emis, nspec, nspec_out
+
     USE chemistry_model_mod,                                                   &
-        ONLY:  chem_emissions, chem_species
-
-    USE chem_modules,                                                          &
-        ONLY:  nspec 
+        ONLY:  chem_boundary_conds, chem_species
 
     USE control_parameters,                                                    &
@@ -426,4 +435,7 @@
         ONLY:  cpu_log, log_point, log_point_s
 
+    USE date_and_time_mod,                                                     &
+        ONLY:  calc_date_and_time, hour_call_emis, hour_of_year
+
     USE flight_mod,                                                            &
         ONLY:  flight_measurement
@@ -450,9 +462,9 @@
                lsf_nesting_offline, lsf_nesting_offline_mass_conservation
 
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  nest_offl, netcdf_data_input_lsf
-
     USE multi_agent_system_mod,                                                &
         ONLY:  agents_active, multi_agent_system
+
+    USE netcdf_data_input_mod,                                                 &
+        ONLY:  chem_emis, chem_emis_att, nest_offl, netcdf_data_input_lsf
 
     USE ocean_mod,                                                             &
@@ -525,7 +537,9 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=9) ::  time_to_string          !< 
-
-    INTEGER(iwp)      ::  n  !< loop counter for chemistry species
+    CHARACTER (LEN=9) ::  time_to_string   !<
+
+    INTEGER(iwp)      ::  lsp       !<
+    INTEGER(iwp)      ::  lsp_usr   !<
+    INTEGER(iwp)      ::  n         !< loop counter for chemistry species
 
     REAL(wp) ::  dt_3d_old  !< temporary storage of timestep to be used for
@@ -611,4 +625,11 @@
            bc_pt_t_val = ( pt_init(nzt+1) - pt_init(nzt) ) / dzu(nzt+1)
            bc_q_t_val  = ( q_init(nzt+1) - q_init(nzt) ) / dzu(nzt+1)
+           IF ( air_chemistry )  THEN
+              DO  lsp = 1, nspec
+                 bc_cs_t_val = (  chem_species(lsp)%conc_pr_init(nzt+1)       &
+                                - chem_species(lsp)%conc_pr_init(nzt) )       &
+                               / dzu(nzt+1)
+              ENDDO
+           ENDIF
        ENDIF
 !
@@ -783,6 +804,16 @@
           IF ( passive_scalar )  CALL exchange_horiz( s_p, nbgp )
           IF ( air_chemistry )  THEN
-             DO  n = 1, nspec     
-                CALL exchange_horiz( chem_species(n)%conc_p, nbgp ) 
+             DO  lsp = 1, nspec
+                CALL exchange_horiz( chem_species(lsp)%conc_p, nbgp )
+!
+!--             kanani: Push chem_boundary_conds after CALL boundary_conds
+                lsp_usr = 1
+                DO WHILE ( TRIM( cs_name( lsp_usr ) ) /= 'novalue' )
+                   IF ( TRIM(chem_species(lsp)%name) == TRIM(cs_name(lsp_usr)) )  THEN
+                      CALL chem_boundary_conds( chem_species(lsp)%conc_p,              &
+                                                chem_species(lsp)%conc_pr_init )
+                   ENDIF
+                   lsp_usr = lsp_usr + 1
+                ENDDO
              ENDDO
           ENDIF
@@ -1122,9 +1153,14 @@
 !
 !--    If required, consider chemical emissions
-!--    (todo (FK): Implement hourly call of emissions, using time_utc from
-!--                data_and_time_mod.f90;
-!--                move the CALL to appropriate location)
-       IF ( air_chemistry ) THEN
-          CALL chem_emissions
+       IF ( air_chemistry  .AND.  do_emis )  THEN
+!
+!--       Update the time --> kanani: revise location of this CALL
+          CALL calc_date_and_time
+!
+!--       Call emission routine only once an hour
+          IF (hour_of_year  .GT.  hour_call_emis )  THEN
+             CALL chem_emissions_setup( chem_emis_att, chem_emis, nspec_out )
+             hour_call_emis = hour_of_year
+          ENDIF
        ENDIF
 !
